<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.threaded.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'zh',
  ),
  'this' => 
  array (
    0 => 'threaded.wait.php',
    1 => 'Threaded::wait',
  ),
  'up' => 
  array (
    0 => 'class.threaded.php',
    1 => 'Threaded',
  ),
  'prev' => 
  array (
    0 => 'threaded.synchronized.php',
    1 => 'Threaded::synchronized',
  ),
  'next' => 
  array (
    0 => 'class.thread.php',
    1 => 'Thread',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'zh',
    'path' => 'reference/pthreads/threaded/wait.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="threaded.wait" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">Threaded::wait</h1>
  <p class="verinfo">(PECL pthreads &gt;= 2.0.0)</p><p class="refpurpose"><span class="refname">Threaded::wait</span> &mdash; <span class="dc-title">Synchronization</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-threaded.wait-description">
  <h3 class="title">说明</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>Threaded::wait</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.integer.php" class="type int">int</a></span> <code class="parameter">$timeout</code><span class="initializer"> = ?</span></span>): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>

  <p class="para rdfs-comment">
   让发起调用的线程上下文进入等待状态，直到收到其他线程的唤醒通知
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-threaded.wait-parameters">
  <h3 class="title">参数</h3>
  <dl>
   
    <dt><code class="parameter">timeout</code></dt>
    <dd>
     <p class="para">
  可选参数，等待时间，以微秒计
     </p>
    </dd>
   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-threaded.wait-returnvalues">
  <h3 class="title">返回值</h3>
  <p class="para">
   成功时返回 <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>， 或者在失败时返回 <strong><code><a href="reserved.constants.php#constant.false">false</a></code></strong>。
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-threaded.wait-examples">
  <h3 class="title">示例</h3>
  <p class="para">
   <div class="example" id="example-3487">
    <p><strong>示例 #1 等待和唤醒</strong></p>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">class </span><span style="color: #0000BB">My </span><span style="color: #007700">extends </span><span style="color: #0000BB">Thread </span><span style="color: #007700">{<br />    public function </span><span style="color: #0000BB">run</span><span style="color: #007700">() {<br />        </span><span style="color: #FF8000">/** 让本线程进入等待状态 **/<br />        </span><span style="color: #0000BB">$this</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">synchronized</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$thread</span><span style="color: #007700">){<br />            if (!</span><span style="color: #0000BB">$thread</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">done</span><span style="color: #007700">)<br />                </span><span style="color: #0000BB">$thread</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">wait</span><span style="color: #007700">();<br />        }, </span><span style="color: #0000BB">$this</span><span style="color: #007700">);<br />    }<br />}<br /></span><span style="color: #0000BB">$my </span><span style="color: #007700">= new </span><span style="color: #0000BB">My</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$my</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">start</span><span style="color: #007700">();<br /></span><span style="color: #FF8000">/** 向处于等待状态的线程发送唤醒通知 **/<br /></span><span style="color: #0000BB">$my</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">synchronized</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$thread</span><span style="color: #007700">){<br />    </span><span style="color: #0000BB">$thread</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">done </span><span style="color: #007700">= </span><span style="color: #0000BB">true</span><span style="color: #007700">;<br />    </span><span style="color: #0000BB">$thread</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">notify</span><span style="color: #007700">();<br />}, </span><span style="color: #0000BB">$my</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$my</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">join</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

    <div class="example-contents"><p>以上示例会输出：</p></div>
    <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">bool(true)</pre>
</div>
    </div>
   </div>
  </p>
 </div>

</div><?php manual_footer($setup); ?>